﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AutoLoL.Entities
{
    public enum GameType
    {
        Classic,
        Dominion,
        ARAM
    };

    public class ChampionBuild
    {
        public Guid ChampionBuildId { get; set; }

        public string Title { get; set; }

        public Champion Champion { get; set; }

        public MasteryBuild MasteryBuild { get; set; }

        public string Guide { get; set; }

        public GameType GameType { get; set; }

        private Item[] _items = new Item[6] { null, null, null, null, null, null };
        public Item[] Items
        {
            get
            {
                return _items;
            }
            set
            {
                if (value == null || value.Length != 6)
                {
                    throw new Exception("Length of array is expected to be 6");
                }

                _items = value;
            }
        }

        private SummonerSpell[] _summonerSpells = new SummonerSpell[2] { null, null };
        public SummonerSpell[] SummonerSpells
        {
            get
            {
                return _summonerSpells;
            }
            set
            {
                if (value == null || value.Length != 2)
                {
                    throw new Exception("Length of array is expected to be 2");
                }

                _summonerSpells = value;
            }
        }
    }
}
